import java.awt.Point;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class KPData implements Cloneable{
	//----------萔------------
	//iSum.data,Part.dataR,Dj
	static final int DATA_MINUS=-1;
	static final int DATA_NONE=0;
	//itype[][]j
	static final int TYPE_SUM=0;
	static final int TYPE_PART=1;
	//----------ϐ------------
	//
	//pY̑傫
	int width,height;
	//ef[^
	int type[/*width*/][/*height*/];		//eW̃IuWFNg̎
	Object contents[/*width*/][/*height*/];	//ݕ\̃IuWFNgz
	//G[
	ArrayList<KPError> errors=new ArrayList<KPError>();
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KPData(){
		formatPuzzle(12,12);
	}
	//wTCYŐVpY쐬
	public void formatPuzzle(int w,int h){
		width=w;
		height=h;
		type=new int[width][height];
		contents=new Object[width][height];
		//	<P.zu>
		for(int x=0;x<width;x++){		//Sum(㉡)
			type[x][0]=TYPE_SUM;
			contents[x][0]=new KPSum();
		}
		for(int y=1;y<height;y++){		//Sum(c)
			type[0][y]=TYPE_SUM;
			contents[0][y]=new KPSum();
		}
		for(int y=1;y<height;y++){		//Part(ȊO)
			for(int x=1;x<width;x++){
				type[x][y]=TYPE_PART;
				contents[x][y]=new KPPart(DATA_NONE);
			}
		}
		//	<Q.͂ƃG[o>
		errors.clear();	//ɂ܂ł̃G[ZbgĂ
		readyNewPuzzle();
		//	<R.͉\𓱏o>
		resetAllInableNums();
	}
	//Rs[p
	private KPData(KPData data){
		width=data.width;
		height=data.height;
		type=new int[width][height];
		contents=new Object[width][height];
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				type[w][h]=data.type[w][h];
				switch(type[w][h]){
				case TYPE_SUM:
					//
					contents[w][h]=( (KPSum)(data.contents[w][h]) ).clone();
					break;
				case TYPE_PART:
					//
					contents[w][h]=( (KPPart)(data.contents[w][h]) ).clone();
					break;
				}
			}
		}
		for(int e=0;e<data.errors.size();e++){
			errors.add(data.errors.get(e).clone());
		}
	}
	public KPData clone(){
		return new KPData(this);
	}
	//******************************************************************************************************
	//	<Q.͂ƃG[o>	PartESumzZbgAZoEG[o
	//------------------------------------------------------------------------------------------------------
	private void readyNewPuzzle(){
		for(int h=0;h<height;h++){	//
			for(int w=0;w<width;w++){	//
				if(type[w][h]==TYPE_SUM){
					//
					KPSum sum=(KPSum)(contents[w][h]);
					//***cs
					readyNewSum(sum,w,h,KPSum.DIR_DOWN);
					//***s
					readyNewSum(sum,w,h,KPSum.DIR_RIGHT);
				}
			}
		}
	}
	private void readyNewSum(KPSum sum,int px,int py,int pz){
		//	<Q|P.͂Sum̃G[o>
		//
		int limit;
		if(pz==KPSum.DIR_DOWN){
			limit=height-py;
		}else{
			limit=width-px;
		}
		//
		int cell=0;
		int pos=1;
		//xzPartɏm点
		while(pos<limit){
			int x=px+pos*KPSum.DIR_VEC[pz].width;
			int y=py+pos*KPSum.DIR_VEC[pz].height;
			if(type[x][y]==TYPE_PART){
				((KPPart)(contents[x][y])).setBelong(new Point(px,py),pz);
				cell+=1;
				pos+=1;
			}else{		//Partr؂ΏI
				break;
			}
		}
		//SumɔzZbgZo
		int erT=sum.setPartNumAndPrepareCombi(cell, pz);
		if(erT!=KPError.ER_NONE){				//Sum̏ŃG[Ăi[
			errors.add(new KPError(erT,px,py,pz));
		}
		//	<Q|Q.Part̃G[o>
		checkBelongPartError(sum,px,py,pz,cell);
	}
	//	<Q|Q.Part̃G[o>	zPart𒲂ׂ
	private void checkBelongPartError(int px,int py,int pz){
		KPSum sum=(KPSum)contents[px][py];
		if(sum.isActive(pz)){
			checkBelongPartError(sum,px,py,pz,sum.getPartNum(pz));
		}
	}
	private void checkBelongPartError(KPSum sum,int px,int py,int pz,int cell){
		int all=0;	//SPart̍v
		int[] pos=new int[10];				//̐OɏoʒuiSum̋j
		boolean[] first=new boolean[10];	//̐̏d̏`FbNtO
		for(int i=0;i<10;i++){
			pos[i]=0;
			first[i]=true;
		}
		KPError er=null;	//dG[p
		//
		boolean fill=true;	//SĂPart܂Ă邩
		for(int c=1;c<=cell;c++){
			KPPart part=(KPPart)(contents[px+c*KPSum.DIR_VEC[pz].width][py+c*KPSum.DIR_VEC[pz].height]);
			int dat=part.getData();
			if(dat==DATA_NONE){	//͂Ȃ玟Part
				fill=false;	//tO낵Ă
				continue;
			}
			//
			all+=dat;	//vvZ
			if(pos[dat]!=0){						//̐ɏoĂ
				if(er==null){	er=new KPError(KPError.ER_PART_OVERLAP,px,py,pz);	}	//dG[
				if(first[dat]){						//dł
					er.addOverlapPoint(pos[dat]);	//Öʒui[
					first[dat]=false;				//tO낷
				}
				er.addOverlapPoint(c);				//̈ʒui[
			}
			pos[dat]=c;								//
		}
		//dG[NĂΊi[
		if(er!=null){
			errors.add(er);
		}
		//SPart܂Ă΍vr
		if(fill){
			if(sum.isActive(pz) && sum.filled(pz) && sum.getData(pz)!=all){
				errors.add(new KPError(KPError.ER_PART_UNFIT,px,py,pz));				//vsvG[
			}
		}
	}
	//******************************************************************************************************
	//	<R.͉\𓱏o>	CombiInableNum
	//------------------------------------------------------------------------------------------------------
	//傫ȕύXƂAŜoȂ
	public void resetAllInableNums(){
		//܂ASumCombiƔzParto
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(type[w][h]==TYPE_SUM){
					for(int d=0;d<KPSum.DIR_ALL;d++){
						//SumHalfɃG[邩ǂniS͕sɂȂ̂Łj
						((KPSum)(contents[w][h])).setInableNum(contents, w, h, d,containError(w,h,d));
					}
				}
			}
		}
		//ɁAPartŏSumo
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(type[w][h]==TYPE_PART){
					((KPPart)(contents[w][h])).setInableNum(contents);
				}
			}
		}
	}
	//PartPƂ̕ύXŁAe͈͂̂ݏoȂ
	private void resetRelativeInableNums(int px,int py){
		Point[] pt=((KPPart)(contents[px][py])).getBelong();
		//
		resetBelongPartsInableNums(pt);
	}
	private void resetBelongPartsInableNums(Point[] pt){
		for(int d=0;d<KPSum.DIR_ALL;d++){
			resetBelongPartsInableNum(pt[d].x,pt[d].y,d);
		}
	}
	private void resetBelongPartsInableNum(int px,int py,int pz){
		KPSum sum=(KPSum)(contents[px][py]);	//ύXꂽPartSum
		//SumHalfɃG[邩ǂniS͕sɂȂ̂Łj
		sum.setInableNum(contents, px, py, pz,containError(px,py,pz));
		sum.setPartInableNums(contents, px, py, pz);	//SumzPartSĂΏ
	}
	//******************************************************************************************************
	//G[
	//------------------------------------------------------------------------------------------------------
	private boolean containError(int x,int y,int z){			//̈ʒuSumɉG[邩
		for(int e=0;e<errors.size();e++){
			KPError er=(KPError)(errors.get(e));
			if(er.agreeErrorPos(x, y, z)){	return true;	}
		}
		//
		return false;
	}
	public boolean containSumError(int x,int y,int z){		//̈ʒuSumSum̂̃G[邩
		for(int e=0;e<errors.size();e++){
			KPError er=(KPError)(errors.get(e));
			if(er.agreeSumErrorPos(x, y, z)){	return true;	}
		}
		//
		return false;
	}
	private void deleteError(int x,int y,int z,boolean partOnly){	//̈ʒuSum̃G[폜itOPart݂̂ݎwj
		//tOirō폜Ȃ炾ƓŶŁj
		boolean[] pEr=new boolean[errors.size()];
		for(int e=0;e<pEr.length;e++){
			pEr[e]=false;
		}
		//̈ʒuSumPart݂̂tO𗧂Ă
		for(int e=0;e<pEr.length;e++){
			KPError er=(KPError)(errors.get(e));
			if(partOnly){								//
				if(er.agreePartErrorPos(x, y, z)){	pEr[e]=true;	}
			}else{										//
				if(er.agreeErrorPos(x, y, z)){		pEr[e]=true;	}
			}
		}
		//폜iŶhߍŌォ炨Ȃj
		for(int e=pEr.length-1;e>=0;e--){
			if(pEr[e]){	errors.remove(e);	}
		}
	}
	private void deleteAllPartError(){							//Part݂̃G[폜
		//tOirō폜Ȃ炾ƓŶŁj
		boolean[] pEr=new boolean[errors.size()];
		for(int e=0;e<pEr.length;e++){
			pEr[e]=false;
		}
		//Part݂̂tO𗧂Ă
		for(int e=0;e<pEr.length;e++){
			KPError er=(KPError)(errors.get(e));
			if(!er.isSumError()){	pEr[e]=true;	}
		}
		//폜iŶhߍŌォ炨Ȃj
		for(int e=pEr.length-1;e>=0;e--){
			if(pEr[e]){	errors.remove(e);	}
		}
	}
	//******************************************************************************************************
	//Ֆʂ̈ꊇ
	//------------------------------------------------------------------------------------------------------
	//𓚂̏iPartf[^ƋPartSum̃j
	public void formatAnswer(){
		//	<P.zu>	Sum̃f[^͂̂܂
		for(int j=0;j<height;j++){	//
			for(int i=0;i<width;i++){	//
				if(type[i][j]==TYPE_PART){
					((KPPart)(contents[i][j])).formatAnswer();
				}else if(type[i][j]==TYPE_SUM){
					((KPSum)(contents[i][j])).formatAnswer();
				}
			}
		}
		//	<Q.͂ƃG[o>	Part݂̃G[̂ݍ폜(VȃG[͔Ȃ̂Ń`FbNsv)
		deleteAllPartError();
		//	<R.͉\𓱏o>	SĎZoȂKv
		resetAllInableNums();
	}
	//Partf[^ĂSum΁AvvZSumɓ
	public void reflectAnswer(){
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				//
				if(type[w][h]==TYPE_SUM){
					KPSum sum=(KPSum)(contents[w][h]);
loop:				for(int d=0;d<KPSum.DIR_ALL;d++){
						if(sum.isActive(d) && !sum.filled(d)){
							//G[Β~Ď
							if(containError(w,h,d)){
								continue;
							}
							//
							int partNum=sum.getPartNum(d);
							int sumData=0;
							for(int p=0;p<partNum;p++){
								KPPart part=(KPPart)(contents[w+(p+1)*KPSum.DIR_VEC[d].width][h+(p+1)*KPSum.DIR_VEC[d].height]);
								if(part.filled()){		//vɉĂ
									sumData+=part.getData();
								}else{					//ł󗓂Β~Ď
									continue loop;
								}
							}
							//vSumɓ
							if(sumData<=KPSum.DATA_MAX[9]){
								setSumData(sumData,w,h,d);	//<P>A<Q>A<R>Ă
							}
						}
					}
				}
			}
		}
	}
	//͍ςSum̃f[^iSumł邱ƂɕύX͂Ȃj
	public void deleteQuestionData(){
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				//
				if(type[w][h]==TYPE_SUM){
					KPSum sum=(KPSum)(contents[w][h]);
					for(int d=0;d<KPSum.DIR_ALL;d++){
						if(sum.isActive(d) && sum.filled(d)){
							//
							setSumData(DATA_MINUS,w,h,d);	//<P>A<Q>A<R>Ă
						}
					}
				}
			}
		}
	}
	//******************************************************************************************************
	//f[^ύXi}EXCxgƃL[Cxgɂj
	//------------------------------------------------------------------------------------------------------
	//폜
	public void deleteCellData(int px,int py){
		if(type[px][py]==TYPE_PART){
			setPartData(DATA_NONE,px,py);	//PartȂf[^폜̂
		}else{
			//⍶[Sum͍폜łȂ
			if(px==0 || py==0){	return;	}
			//	<P.zu>	Sum폜Part
			type[px][py]=TYPE_PART;
			contents[px][py]=new KPPart(DATA_NONE);
			//	<Q.͂ƃG[o>	Sum폜ꍇ͂̈ʒũG[폜̂
			deleteError(px,py,KPSum.DIR_DOWN,false);
			deleteError(px,py,KPSum.DIR_RIGHT,false);
			//	ƍ̏㗬Sumɂ<Q><R>Ȃi<P>͕svj
			resetBelongPartsInableNums(resetUpperSums(px,py));
		}
	}
	//
	public void setSumData(int dat,int px,int py,int pz){
		if(type[px][py]==TYPE_PART){
			KPSum sum=new KPSum();
			//	<P.zu>	Part폜Sum
			type[px][py]=TYPE_SUM;
			contents[px][py]=sum;
			if(dat>DATA_NONE){	//f[^鎞̂݉imSumKvȂŉj
				sum.addSumHalf(pz, dat);			//PP^
			}
			//	<Q.͂ƃG[o>
			readyNewSum(sum,px,py,KPSum.DIR_DOWN);
			readyNewSum(sum,px,py,KPSum.DIR_RIGHT);
			//	<R.͉\𓱏o>
			resetBelongPartsInableNums(new Point[]{new Point(px,py),new Point(px,py)});
			//	ƍ̏㗬Sumɂ<Q><R>Ȃi<P>͕svj
			resetBelongPartsInableNums(resetUpperSums(px,py));
		}else{
			KPSum sum=(KPSum)(contents[px][py]);
			//	<P.zu>	SumɃf[^K
			if(dat==DATA_MINUS){
				sum.deleteSumHalf(pz);	//u-vL[Ȃ猻݂̃f[^폜imSumKvȂŉj
			}else{
				if(sum.isActive(pz)){
					sum.setData(dat, pz);			//QP^ɂȂ邩
				}else{
					if(dat>DATA_NONE){	//f[^鎞̂݉imSumKvȂŉj
						sum.addSumHalf(pz, dat);	//PP^
					}
				}
			}
			//	<Q.͂ƃG[o>
			deleteError(px,py,pz,false);
			readyNewSum(sum,px,py,pz);
			//	<R.͉\𓱏o>
			resetBelongPartsInableNum(px,py,pz);
		}
	}
	//wʒuƍ̏㗬Sumɂ<Q.͂ƃG[o>Ȃ
	private Point[] resetUpperSums(int px,int py){	
		Point[] pt=new Point[KPSum.DIR_ALL];
		for(int d=0;d<KPSum.DIR_ALL;d++){
			//
			int posX=px;
			int posY=py;
			int dist=0;
			while(true){	//㗬Sum܂Ń[viKj
				posX-=KPSum.DIR_VEC[d].width;
				posY-=KPSum.DIR_VEC[d].height;
				dist++;
				if(type[posX][posY]==TYPE_SUM){
					break;
				}
			}
			//
			pt[d]=new Point(posX,posY);
			//
			KPSum sum=(KPSum)(contents[posX][posY]);
			//A͍Sumł΁iœ́ASumǉ݂̎̂肤j
			if(dist==1){
				if( sum.isActive(d) && sum.getData(d)==DATA_NONE ){
					sum.deleteSumHalf(d);	//svɂȂ̂ō폜
				}
			}
			//	<Q.͂ƃG[o>
			deleteError(posX,posY,d,false);
			readyNewSum(sum,posX,posY,d);
		}
		//㗬Sum̈ʒuԂ
		return pt;
	}
	//Part֓
	public void setPartData(int dat,int px,int py){
		KPPart part=(KPPart)(contents[px][py]);
		//	<P.zu>
		part.setData(dat);
		//	<Q.͂ƃG[o>
		Point[] dim=part.getBelong();
		for(int d=0;d<KPSum.DIR_ALL;d++){
			deleteError(dim[d].x,dim[d].y,d,true);
			checkBelongPartError(dim[d].x,dim[d].y,d);
		}
		//	<R.͉\𓱏o>
		//e͈͂̂ݏoȂ
		resetRelativeInableNums(px,py);
	}
	//******************************************************************************************************
	//[h
	//------------------------------------------------------------------------------------------------------
	public boolean setLoadString(String[] ld){
		//ꎞIɊi[imF̂߁j
		int tmpW,tmpH;
		int[][] tmpT;
		Object[][] tmpC;
		//
		int line;	//
		//
		//ƍ
		if(ld!=null && ld.length>=2){
			try{
				tmpH=Integer.parseInt(ld[0]);
				tmpW=Integer.parseInt(ld[1]);
			}catch(NumberFormatException e){
				return false;
			}
		}else{
			return false;
		}
		//ef[^
		tmpT=new int[tmpW][tmpH];
		tmpC=new Object[tmpW][tmpH];
		for(int h=0;h<tmpH;h++){
			for(int w=0;w<tmpW;w++){
				tmpT[w][h]=TYPE_PART;
			}
		}
		//Sum̃f[^Ȃ
		if(ld.length<2+tmpW+tmpH-1){	return false;	}
		//	<P.zu>
		//Sum
		line=2;
		while(line<ld.length){						//
			if(ld[line].length()==0){	break;	}	//
			//
			int[] sumD=changeStringToIntArray(ld[line],false);
			if(sumD==null || sumD.length!=4){	return false;	}
			//
			KPSum sum=new KPSum();
			if(sumD[2]!=DATA_NONE){	sum.addSumHalf(KPSum.DIR_RIGHT, sumD[2]);	}	//
			if(sumD[3]!=DATA_NONE){	sum.addSumHalf(KPSum.DIR_DOWN, sumD[3]);	}	//
			tmpT[sumD[1]][sumD[0]]=TYPE_SUM;
			tmpC[sumD[1]][sumD[0]]=sum;
			//
			line++;
		}
		//
		line++;
		//Part̃f[^Ȃ
		if(ld.length<line+tmpH){	return false;	}
		//Part
		for(int h=0;h<tmpH;h++){
			int[] partD=changeStringToIntArray(ld[h+line],true);
			if(partD==null || partD.length!=tmpW){	return false;	}
			//
			for(int w=0;w<tmpW;w++){
				if(tmpT[w][h]==TYPE_PART){
					tmpC[w][h]=new KPPart(partD[w]);
				}
			}
		}
		//f[^Ă͂
		width=tmpW;
		height=tmpH;
		type=tmpT;
		contents=tmpC;
		//	<Q.͂ƃG[o>
		errors.clear();	//ɂ܂ł̃G[ZbgĂ
		readyNewPuzzle();
		//	<R.͉\𓱏o>
		resetAllInableNums();
		//
		return true;
	}
	private static int[] changeStringToIntArray(String data,boolean periodFlag){
		StringTokenizer st=new StringTokenizer(data," ");
		ArrayList<String> array=new ArrayList<String>();
		while(st.hasMoreTokens()){	//
			array.add(st.nextToken());
		}
		int[] ret=new int[array.size()];
		for(int r=0;r<ret.length;r++){
			//
			if(periodFlag){
				if(array.get(r).equals(".")){
					ret[r]=DATA_NONE;
					continue;
				}
			}
			//
			try{
				ret[r]=Integer.parseInt(array.get(r));
			}catch(NumberFormatException e){
				return null;
			}
			
		}
		//
		return ret;
	}
	public boolean setCSVString(String[] ld){
		//ꎞIɊi[imF̂߁j
		int tmpW,tmpH;
		int[][] tmpT;
		Object[][] tmpC;
		//
		//
		tmpH=ld.length;		//iōs`FbN͕svj
		if(tmpH<=0){	return false;	}
		//(J}̌)
		tmpW=countComma(ld[0]);
		if(tmpW<=0){	return false;	}
		//ef[^
		tmpT=new int[tmpW][tmpH];
		tmpC=new Object[tmpW][tmpH];
		//	<P.zu>
		//es𕪐
		for(int h=0;h<tmpH;h++){	//
			//sG[`FbN
			if(countComma(ld[h])<tmpW){
				return false;			//Ȃ
			}
			//
			int start=-1;
			int end=-1;
			for(int w=0;w<tmpW;w++){	//
				start=end;
				end=ld[h].indexOf(",",start+1);
				//
				if(end==start+1){				//PARTif[^Ȃj[O]
					tmpT[w][h]=TYPE_PART;
					tmpC[w][h]=new KPPart(DATA_NONE);
				}else if(end==start+2){			//PARTif[^j or SUM[P]
					String s=ld[h].substring(start+1,end);
					if( s.equals("\\") ){		//SUM
						tmpT[w][h]=TYPE_SUM;
						tmpC[w][h]=new KPSum();
					}else{						//PART
						tmpT[w][h]=TYPE_PART;
						tmpC[w][h]=new KPPart(s);
					}
				}else{						//SUM or NONE[Qȏ]
					String s=ld[h].substring(start+1,end);
					if( s.equals("0\\0") || s.equals("0\\") || s.equals("\\0") ){	//NONE
						tmpT[w][h]=TYPE_SUM;
						tmpC[w][h]=new KPSum();
					}else{															//SUM
						tmpT[w][h]=TYPE_SUM;
						tmpC[w][h]=new KPSum(s);
					}
				}
			}
		}
		//f[^Ă͂
		width=tmpW;
		height=tmpH;
		type=tmpT;
		contents=tmpC;
		//	<Q.͂ƃG[o>
		errors.clear();	//ɂ܂ł̃G[ZbgĂ
		readyNewPuzzle();
		//	<R.͉\𓱏o>
		resetAllInableNums();
		//
		return true;
	}
	private static int countComma(String data){
		int ret=-1;
		int pos=-1;
		do{		//J}̌ij߂郋[v
			ret+=1;
			pos=data.indexOf(",",pos+1);
		}while(pos!=-1);		//J}ȂȂ΃[v𔲂
		//
		return ret;
	}
	//******************************************************************************************************
	//Z[u
	//------------------------------------------------------------------------------------------------------
	public String getSaveString(boolean answerOutput){
		String br=System.getProperty("line.separator");
		StringBuffer ret=new StringBuffer();
		//Z[uf[^쐬
		//cE
		ret.append(height).append(br);
		ret.append(width).append(br);
		//Sum
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(type[w][h]==TYPE_SUM){
					KPSum sum=(KPSum)(contents[w][h]);
					//
					ret.append(h).append(" ").append(w);
					for(int d=KPSum.DIR_ALL-1;d>=0;d--){	//
						if( sum.isActive(d) ){
							ret.append(" ").append(sum.getData(d));
						}else{
							ret.append(" ").append(DATA_NONE);
						}
					}
					//
					ret.append(br);
				}
			}
		}
		ret.append(br);
		//Part
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(type[w][h]==TYPE_PART){
					KPPart part=(KPPart)(contents[w][h]);
					if(answerOutput && part.filled()){	//ʏ͉𓚂o
						ret.append(part.getData()).append(" ");
					}else{								//Appleto͂
						ret.append(". ");
					}
				}else{
					ret.append(". ");
				}
			}
			ret.append(br);
		}
		//
		return ret.toString();
	}
	public String getCSVString(boolean answerOutput){
		//CSVf[^쐬
		StringBuffer buf=new StringBuffer();
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				switch(type[w][h]){
				case TYPE_SUM:
					if( ((KPSum)(contents[w][h])).isActive(KPSum.DIR_DOWN) ){
						buf.append(((KPSum)(contents[w][h])).getData(KPSum.DIR_DOWN));
					}
					buf.append("\\");
					if( ((KPSum)(contents[w][h])).isActive(KPSum.DIR_RIGHT) ){
						buf.append(((KPSum)(contents[w][h])).getData(KPSum.DIR_RIGHT));
					}
					buf.append(",");
					break;
				case TYPE_PART:
					if( answerOutput && ((KPPart)(contents[w][h])).filled() ){	//ʏ͉𓚂o
						buf.append(((KPPart)(contents[w][h])).getData());
					}															//Appleto͂
					buf.append(",");
					break;
				default:
				}
			}
			buf.append("]"+System.getProperty("line.separator"));
		}
		//
		return buf.toString();
	}
	//******************************************************************************************************
	//DataFrameւ̏o
	//------------------------------------------------------------------------------------------------------
	//f[^o̓tH[
	public String setDataFromIOFrame(String csvData){	//G[΃bZ[WԂ
		//
		//s폜A"]"ŉ̍sɕ
		String[] lines=( csvData.replace(System.getProperty("line.separator"), "") ).split("]");
		//߂
		if(lines.length!=height){
			return LST.makeErrorMessage(LST.VERTICAL);			//***G[
		}
		//߂
		for(int h=0;h<height;h++){	//sƂ
			if(countComma(lines[h])<width){
				return LST.makeErrorMessage(LST.HORIZONTAL);		//***G[
			}
		}
		//
		//PARTeꎞf[^
		int[][] tmpData=new int[width][height];
		//es𕪐͂ăf[^`FbNAG[Ȃꎞf[^ɓ
		for(int h=0;h<height;h++){	//sƂ
			//
			int start=-1;
			int end=-1;
			String dat;
			for(int w=0;w<width;w++){	//}XƂ
				start=end;
				end=lines[h].indexOf(",",start+1);
				dat=lines[h].substring(start+1,end);
				//
				switch(type[w][h]){
				case TYPE_SUM:
					if( !(((KPSum)(contents[w][h])).checkInputData(dat)) ){
						return LST.makeErrorMessage(w+1, h+1);		//***SUMf[^G[
					}
					break;
				case TYPE_PART:
					if(dat.length()>=2 || dat.length()<0 ){
						return LST.makeErrorMessage(w+1, h+1);		//***PARTf[^G[iL蓾Ȃj
					}else if(dat.length()==0){
						tmpData[w][h]=0;
					}else{
						try{
							tmpData[w][h]=Integer.parseInt(dat);
						}catch(NumberFormatException e){	//񂪐ł͂ȂO̓G[
							return LST.makeErrorMessage(w+1, h+1);	//***PARTf[^G[iłȂj	
						}
					}
					break;
				}
			}
		}
		//	<P.zû>
		//PARTeꎞf[^pYɓK
		for(int h=0;h<height;h++){	//
			for(int w=0;w<width;w++){	//
				if(type[w][h]==TYPE_PART){
					((KPPart)(contents[w][h])).setData( tmpData[w][h] );
				}
			}
		}
		//	<Q.͂ƃG[o>
		//Part݂̃G[̂ݍ폜
		deleteAllPartError();
		//Part݂̃G[`FbNȂ
		for(int h=0;h<height;h++){	//
			for(int w=0;w<width;w++){	//
				if(type[w][h]==TYPE_SUM){
					for(int d=0;d<KPSum.DIR_ALL;d++){
						checkBelongPartError(w,h,d);
					}
				}
			}
		}
		//	<R.͉\𓱏o>
		//SPart̓KȂ̂ŁASĎZoȂKv
		resetAllInableNums();
		//
		return null;
	}
	//******************************************************************************************************
	//͂̑ÕG[`FbN
	//------------------------------------------------------------------------------------------------------
	//G[Pifj
	public boolean checkFragment(){
		//
		boolean[][] touch=new boolean[width][height];
		for(int x=0;x<width;x++){
			for(int y=0;y<height;y++){
				touch[x][y]=false;
			}
		}
		//ł邾SɂPartTiԒZk̂߁j
		int cx=(int)(width/2);
		int cy=(int)(height/2);
		if(type[cx][cy]!=TYPE_PART){
			int d=1;
			while(true){	//EɒTĂ
				if(cx-d>0){
					if(type[cx-d][cy]==TYPE_PART){
						cx-=d;
						break;
					}
				}
				if(cx+d<width){
					if(type[cx+d][cy]==TYPE_PART){
						cx+=d;
						break;
					}
				}else{
					return true;	//[ɒBĂPartȂȂ番f
				}
				d++;
			}
		}
		//ڂĂPart̃tO𗧂ĂĂ
		touch[cx][cy]=true;
		checkTouch(touch,cx,cy);
		//tO̗ĂȂPartłΕf
		for(int x=0;x<width;x++){
			for(int y=0;y<height;y++){
				if(type[x][y]==TYPE_PART){
					if(!touch[x][y]){	return true;	}
				}
			}
		}
		return false;
	}
	private void checkTouch(boolean[][] touch,int w,int h){
		if(h-1>0 && type[w][h-1]==TYPE_PART){		//
			if(!touch[w][h-1]){				//܂BPartȂ
				touch[w][h-1]=true;			//tO𗧂Ă
				checkTouch(touch,w,h-1);	//Part̂S𓯗lɃ`FbNiċAĂяoj
			}
		}
		if(h+1<height && type[w][h+1]==TYPE_PART){	//
			if(!touch[w][h+1]){
				touch[w][h+1]=true;
				checkTouch(touch,w,h+1);
			}
		}
		if(w-1>0 && type[w-1][h]==TYPE_PART){		//
			if(!touch[w-1][h]){
				touch[w-1][h]=true;
				checkTouch(touch,w-1,h);
			}
		}
		if(w+1<width && type[w+1][h]==TYPE_PART){	//E
			if(!touch[w+1][h]){
				touch[w+1][h]=true;
				checkTouch(touch,w+1,h);
			}
		}
	}
	//G[QimSumj
	public KPError checkSumsFilled(){
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(type[w][h]==TYPE_SUM){
					KPSum sum=(KPSum)(contents[w][h]);
					//
					for(int d=0;d<KPSum.DIR_ALL;d++){
						if(sum.isActive(d) && !sum.filled(d)){
							return new KPError(KPError.ER_SUM_NONE,w,h,d);
						}
					}
				}
			}
		}
		//
		return null;
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public KPError searchBlankPart(){
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				//
				if(type[w][h]==TYPE_PART){
					if( !((KPPart)(contents[w][h])).filled() ){
						return new KPError(KPError.ER_PART_NONE,w,h,KPSum.DIR_DOWN);
					}
				}
			}
		}
		//
		return null;
	}
	//******************************************************************************************************
	//
	//------------------------------------------------------------------------------------------------------
	public void formatChanges(){
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if(type[w][h]==TYPE_SUM){
					((KPSum)(contents[w][h])).setChanges(true);	//
				}
			}
		}
	}
	public boolean checkNoPartBlank(){
		for(int h=0;h<height;h++){
			for(int w=0;w<width;w++){
				if( type[w][h]==TYPE_PART && !((KPPart)(contents[w][h])).filled() ){
					return false;		//Partɋ󗓂ł
				}
			}
		}
		return true;
	}
}
